

#property indicator_chart_window
extern string _Manual_scale_input_;

extern double    pH1=0;    //  Gann scale H1 (0 - automatic scaling)
extern double    pH4=0;    //  Gann scale H4 (0 - automatic scaling) current week
extern double    pH4W_1=0; //  Gann scale H4 (0 - automatic scaling) week ago
extern double    pH4W_2=0; //  Gann scale H4 (0 - automatic scaling) 2 weeks ago

extern string _Scaling_W_angle_H1_H4_;
extern bool H4_H1 = False;   // Switch on depicting of weekly angles H4 on H1

extern string _Shif_GMT_;
extern int       DiffTime = 0;        // Difference betweeb terminal time and UTC

extern string ___Time_Open_session___;
extern int Asia=2;     // Beginning of a day
extern int Europe=7;   // Beggining of European session - Frankfurt Exchange open (UTC)
extern int America=13; // Beginning of American session - NYSE open (UTC)

extern string __Calculation_of_angles_;
extern bool      NextWeek=True;         // True - switch Saturday to Monday 
extern bool      NextDay=False;         // True - switch to next day
extern bool      ExtDay=False;          // True - extend daily line one day ahead
extern bool      FromShadow=False;      // if Yes - count extremum from shadow (wick)of last candle, if No - from body.
extern bool      Line=False;            // Switch on or of angles of yesterday and current day
extern bool      Day_minmax=True;       // Min  max yesterday
extern bool      Wik_op=True;          // Angle of current week
extern bool      Wik_minmax=False;      // Min max current week
extern bool      Wik_1_op=True;        // Angle of a week ago   
extern bool      Wik_1_minmax=True;    // Min max week ago
extern bool      Wik_2_minmax=False;    // Angle of 2 weeks ago
extern bool      Wik_3_minmax=False;    // Angle of 3 weeks ago

extern string __Net_making__= "To experiment with Gann nets switch of Grid_standard";
extern bool      Grid_standard=True;         // Standart making of net
extern bool      Grid_today=False;           // On / off net of today
extern bool      Grid_yesterday=False;       // On / off net yesterday
extern bool      Grid_double_H_1=False;      // If yes - net is doubled
extern bool      Grid_double_H_4=False;      // If yes - net is doubled
extern bool      Day_before_yesterday=False; // If yes - two days ago and yesterday, no - yestreday and today.
extern bool      Last_week=False;            // If yes - shift one week back.

extern string ____Pickup_Fibo_____ = "0-no,1-Fibo,2-Gann";
extern int  FiboSelect   = 1;         // 0-no,1 - Fibo, 2 - Gann.
extern color FiboColor   = Black;     // Line colour
extern int   FiboStyle   = 1;         // Line style
extern int   FiboWight   = 0;         // Line thickness

extern string ____Channel_making_____ = "false-no,true-make it";
extern bool  Opening_yesterday   = False;
extern bool  High_Low            = False;  
    
extern string ____Channel_upwards;

extern color ChColorOpenUp   = ForestGreen;   // upward channel colour
extern color ChColorMax      = FireBrick;   // upward channel colour
extern int   ChStyleMax      = 1;           // line style
extern int   ChWightMax      = 1;           // line thickness

extern string ____Channel_downwards;

extern color ChColorOpenDown   = DeepPink;   // downward channel colour
extern color ChColorMin        = Indigo;   // downward channel colour
extern int   ChStyleMin        = 1;        // line style
extern int   ChWightMin        = 1;        // line thickness

extern string _Making_S_R_min_max_ = "false-no,true-make it";
extern bool  S_R   = false;
extern color R_Color   = Blue;     // colour of resistance
extern color S_Color   = Red;      // colour of support

extern string ____Resistance;

extern int   S_R_Max_Style   = 0;        // line style
extern int   S_R_Max_Wight   = 1;        // line thickness

extern string ____Support;

extern int   S_R_Min_Style   = 0;        // line style
extern int   S_R_Min_Wight   = 1;        // line thickness

extern string _Draw_S_R_Fibo_ = "false-no,true-draw it";

extern bool  S_R_Fibo         = false;
extern color Op_Day_Color     = DarkGoldenrod; // colour of day open
extern color R_Fibo_Color     = RoyalBlue;     // colour of resistance
extern color S_Fibo_Color     = DeepPink;      // colour of support
extern int   S_R_Fibo_Style   = 2;             // style
extern int   S_R_Fibo_Width   = 1;             // thickness
extern int   S_R_Fibo_Ray     = 0;             // ray

double FiboLevel[]            = {  -4.00    ,   -3.618    ,    -3.382     ,    -3.236     ,   -3.0     ,    -2.618     ,    -2.382     ,    -2.236     ,    -2.0     ,    -1.618     ,    -1.382     ,    -1.236     ,    -1.0     ,    -0.618     ,    -0.382     ,    -0.236    ,   0           ,    0.118           ,    0.236           ,    0.382           ,    0.5    ,    0.618           ,    0.764           ,    0.882           ,    1           ,    1.236     ,    1.382     ,    1.618     ,    2.0     ,    2.236     ,    2.382     ,    2.618    ,     3.0     ,    3.236     ,   3.382    ,      3.618     ,    4.0    ,     4.236     ,    4.382     ,   4.618     ,   5.0     ,     100000};     
string FiboDescription[]      = {" -500  %$", " -461.8 %$",  " -438.2  %$",  " -423.6  %$", " -400  %$",  " -361.8  %$",  " -338.2  %$",  " -323.6  %$",  " -300  %$",  " -261.8  %$",  " -238.2  %$",  " -223.6  %$",  " -200  %$",  " -161.8  %$",  " -138.2  %$",  " -123.6 %$", " 0---100  %$",  " 11.8---88.2  %$",  " 23.6---76.4  %$",  " 38.2---61.8  %$",  " 50  %$",  " 61.8---38.2  %$",  " 76.4---23.6  %$",  " 88.2---11.8  %$",  " 100---0  %$",  " 123.6  %$",  " 138.2  %$",  " 161.8  %$",  " 200  %$",  " 223.6  %$",  " 238.2  %$",  " 261.8  %$",  " 300  %$",  " 323.6  %$",  " 338.2  %$",  " 361.8  %$",  " 400  %$",  " 423.6  %$",  " 438.2  %$", " 461.8  %$", " 500  %$"}; 
double FiboGann[]             = {  -1.75   ,    -1.666  ,    -1.5    ,    -1.333  ,    -1.25   ,    -1.125    ,    -1    ,    -0.875   ,    -0.75  ,    -0.666   ,    -0.5   ,    -0.375   ,    -0.333   ,    -0.25  ,    -0.125   ,    0    ,    0.125   ,    0.25  ,    0.333   ,    0.375   ,    0.5   ,    0.666   ,    0.75  ,     0.875  ,    1    ,    1.125    ,    1.25   ,    1.333  ,    1.5    ,    1.666  ,    1.75   , 1000000};      // Gann 
string FiboGannDescription[]  = {" -175 %$", "  -166 %$", "  -150 %$", "  -133 %$", "  -125 %$", "  -112.5 %$", "  -1 %$", "  -87.5 %$", "  -75 %$", "  -66.6 %$", "  -50 %$", "  -37.5 %$", "  -33.3 %$", "  -25 %$", "  -12.5 %$", "  0 %$", "  12.5 %$", "  25 %$", "  33.3 %$", "  37.5 %$", "  50 %$", "  66.6 %$", "  75 %$", "  87.5 %$", "  1 %$", "  112.5 %$", "  125 %$", "  133 %$", "  150 %$", "  166 %$", "  175 %$"};// Gann - headings

double DT, P;
string Pr = "G_L_";
int    TimeD0; //beginning of the current day

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  { 
   Delete_My_Obj(Pr);
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
 // shift GMT
   DT = DiffTime*3600;
 // time of the beginning of the current day
   if (Bars < 1440 / Period()) return (0);
   int hour = iTime(NULL, 0, 0);
   int Bar_shift_hour = iBarShift(NULL, PERIOD_D1, hour);
   TimeD0 = iTime(NULL, PERIOD_D1, Bar_shift_hour) + DT;
   if (NextWeek==True)
     { if (TimeDayOfWeek(TimeD0)==6)
       if (TimeDayOfWeek(TimeLocal())==0 || TimeDayOfWeek(TimeLocal())==1 || TimeDayOfWeek(TimeLocal())==6) TimeD0=TimeD0+86400*3; 
     }
   if (TimeDayOfWeek(TimeD0)==0) TimeD0=TimeD0+86400; 
   if (NextDay==True) TimeD0=TimeD0+86400; 

//---- indicators

   Delete_My_Obj(Pr);
   if(Period()<=PERIOD_H1){WriteGH1();}
   if(Period()==PERIOD_H4){WriteGH4();}
    
    return(0);
  }
  
//+------------------------------------------------------------------+

int WriteGH1()
   {
   int TimeD00;  //beginning of the tomorrow
   int TimeD000; //beginning of the two days ahead
   int TimeD1;   //beginning of the yestreday
   int TimeD2;   //beginning of the two days ago
   int minD2;    //min bar of the two days ago
   int maxD2;    //max bar of the two days ago
   int minD1;    //min bar of the day ago
   int maxD1;    //max bar of the day ago
   int TimeN0;   //beginning of the current week
   int minN0;    //min bar of the current week
   int maxN0;    //max bar of the current week
   int TimeN1;   //beginning of the week ago
   int minN1;    //min bar week ago
   int maxN1;    //max bar week ago
   int TimeN2;   //beginning week 2
   int minN2;    //min bar 2 week
   int maxN2;    //max bar 2 week
   int TimeN3;   //beginning week 3
   int minN3;    //min bar 3 week
   int maxN3;    //max bar 3 week
   int TimeN4;   //beginning week 4
   int minN4;    //min bar 4 week
   int maxN4;    //max bar 4 week
   int i=0, j;
   int D;
   double P, Pr1, Pr2, Pr3, MD, MYD, MW, MW_1, MW_2;
   double rez, h, l, r, t;
   
// time of the beginning of the yesterday
   TimeD1=TimeD0-86400; 
   if (TimeDayOfWeek(TimeD0)==0) TimeD1=TimeD0-86400*2; 
   if (TimeDayOfWeek(TimeD0)==1) TimeD1=TimeD0-86400*3;
   
// time of the beginning of the day before yesterday
   TimeD2=TimeD1-86400;    

// time of the beginning of the day ahead 
   TimeD00=TimeD0+86400; 

// time of the beginning of the day ahead or the after tomorrow
   if (ExtDay==False) TimeD000=TimeD00; 
   else               TimeD000=TimeD00+86400; 


// time of the beginning of the current week
   D=TimeDayOfWeek(TimeD0);
   TimeN0=TimeD0-(D-1)*86400;

// time of the beginning of the 4 week
   TimeN1=TimeN0-86400*7;
   
// time of the beginning of the 3 week
   TimeN2=TimeN1-86400*7;
   
// time of the beginning of the 2 week
   TimeN3=TimeN2-86400*7;
   
// time of the beginning of the 1 week
   TimeN4=TimeN3-86400*7;   
         
// min/max of yesterday
     int BarD0=iBarShift(NULL,0,TimeD0+DT);
     int BarD1=iBarShift(NULL,0,TimeD1+DT);
         i=BarD1-BarD0;
         maxD1=iHighest(NULL, 0, MODE_HIGH,i, BarD0+1);
         minD1=iLowest (NULL, 0, MODE_LOW ,i, BarD0+1);
     int BarD2=iBarShift(NULL,0,TimeD2+DT);
         i=BarD2-BarD1;
         maxD2=iHighest(NULL, 0, MODE_HIGH,i, BarD1+1);
         minD2=iLowest (NULL, 0, MODE_LOW ,i, BarD1+1);
         
// min/max of the current week
   int BarN0=iBarShift(NULL,0,TimeN0+DT);
   j=iBarShift(NULL,0,TimeD00+DT);
   i=BarN0-j;
         maxN0=iHighest(NULL, 0, MODE_HIGH,i, j+1);
         minN0=iLowest (NULL, 0, MODE_LOW ,i, j+1);
         
// min/max of 1 week         
   int BarN1=iBarShift(NULL,0,TimeN1+DT);
   j=iBarShift(NULL,0,TimeN0+DT);
   i=BarN1-j;
         maxN1=iHighest(NULL, 0, MODE_HIGH,i, j+1);
         minN1=iLowest (NULL, 0, MODE_LOW ,i, j+1);
         
// min/max of 2 week  
   int BarN2=iBarShift(NULL,0,TimeN2+DT);
   j=iBarShift(NULL,0,TimeN1+DT);
   i=BarN2-j;
         maxN2=iHighest(NULL, 0, MODE_HIGH,i, j+1);
         minN2=iLowest (NULL, 0, MODE_LOW ,i, j+1);
         
// min/max of 3 week  
   int BarN3=iBarShift(NULL,0,TimeN3+DT);
   j=iBarShift(NULL,0,TimeN2+DT);
   i=BarN3-j;
         maxN3=iHighest(NULL, 0, MODE_HIGH,i, j+1);
         minN3=iLowest (NULL, 0, MODE_LOW ,i, j+1);
         
// min/max of 4 week  
   int BarN4=iBarShift(NULL,0,TimeN4+DT);
   j=iBarShift(NULL,0,TimeN3+DT);
   i=BarN3-j;
         maxN4=iHighest(NULL, 0, MODE_HIGH,i, j+1);
         minN4=iLowest (NULL, 0, MODE_LOW ,i, j+1);


// starting weekly points based on wicks (shadows)

if (Close[BarN1]>Open[BarN1])
   Pr2=High[BarN1];
 else Pr2=Low[BarN1]; 

if (Close[BarN0]>Open[BarN0])
   Pr1=High[BarN0];
 else Pr1=Low[BarN0]; 
 

if (pH1==0)
  {
   h=MathAbs(NormalizeDouble(High[maxD1],4)-NormalizeDouble(Low[minD1],4))/Point;
   r=MathPow(24,2); 
   rez=MathPow(h,2);
   MD=MathSqrt(rez+r)/100*Period()/60;
  }
else MD=pH1;
if (Day_before_yesterday)
  {
   h=MathAbs(NormalizeDouble(High[maxD2],4)-NormalizeDouble(Low[minD2],4))/Point;
   r=MathPow(24,2); 
   rez=MathPow(h,2);
   MYD=MathSqrt(rez+r)/100*Period()/60;
   MD=MYD;
  }
  
if (pH4==0)
  {
   if (H4_H1)
    {
     h=MathAbs(NormalizeDouble(High[maxN1],4)-NormalizeDouble(Low[minN1],4))/Point;
     r=MathPow(120,2); 
     rez=MathPow(h,2);
     MW=MathSqrt(rez+r)/100*Period()/240;
    }
   else
    {
     MW=MD;
    }
  }
else  MW=pH4/4;      
if (pH4W_1==0)
    {
     h=MathAbs(NormalizeDouble(High[maxN2],4)-NormalizeDouble(Low[minN2],4))/Point;
     r=MathPow(120,2); 
     rez=MathPow(h,2);
     MW_1=MathSqrt(rez+r)/100*Period()/240;
    }
else    MW_1=pH4W_1/4;
if (pH4W_2==0)
    {
     h=MathAbs(NormalizeDouble(High[maxN3],4)-NormalizeDouble(Low[minN3],4))/Point;
     r=MathPow(120,2); 
     rez=MathPow(h,2);
     MW_2=MathSqrt(rez+r)/100*Period()/240;
    }
else    MW_2=pH4W_2/4; 
 
 Comment (WindowExpertName(	),"\n","\n",
          "Scale        = ",DoubleToStr(NormalizeDouble(MD,4),4),"\n");
  
// time lines
  VLine("Asia",TimeD0+(60*60*Asia),DodgerBlue,STYLE_DOT,1,31);
  VLine("Europe",TimeD0+(60*60*Europe),DodgerBlue,STYLE_DOT,1,31);
  VLine("America",TimeD0+(60*60*America),DodgerBlue,STYLE_DOT,1,31);
  VLine("Beginning of the current day",TimeD0,Maroon,STYLE_DOT,1,31);
  VLine("End of the current day",TimeD00,Maroon,STYLE_DOT,1,31);
  VLine("  ",TimeD00+(60*60*24),Maroon,STYLE_DOT,1,31);
  VLine("Beginning of the current week",TimeN0,Red,STYLE_DOT,1,31);
  VLine("Beginning of the week ago",TimeN1,Red,STYLE_DOT,1,31);
    
   
      if (FromShadow==False) 
      { 
        Pr2=Close[BarN1+1];
        Pr1=Close[BarN0+1]; 
      } 
       
     
   //Angle of the current week
   if (Wik_op)  
      GannLine ("Angle of the current week","Line",TimeN0,Pr1,TimeD00,MW,Turquoise,0,1,31);
     
   //Min / max of the current week
   if (Wik_minmax)
   {
     GannLine ("Max of the current week","Line",Time[maxN0],High[maxN0],TimeD00,MW,DeepPink, 1,1,31);
     GannLine ("Min of the current week","Line",Time[minN0],Low[minN0], TimeD00,MW,DeepPink, 1,1,31);
   }
     
   //Angle of the week ago
   if (Wik_1_op)
     GannLine ("Angle of the week ago","Line",TimeN1,     Pr2,TimeD00,MW,Black,0,1,31);
     
   //Min / max of the week ago
   if (Wik_1_minmax)
   {
     GannLine ("Max of the week ago","Line",Time[maxN1],High[maxN1],TimeD00,MW,Gold, 1,1,31);
     GannLine ("Min of the week ago","Line",Time[minN1],Low[minN1], TimeD00,MW,Gold, 1,1,31);
   }
     
   //min max 2 week
   if (Wik_2_minmax)
   {
     GannLine ("Max 2 week","Line",Time[maxN2],High[maxN2],TimeD00,MW_1,White, 1,1,31);
     GannLine ("Min 2 week","Line",Time[minN2],Low[minN2], TimeD00,MW_1,White, 1,1,31);
   } 
     
   //minmax 3 week
   if (Wik_3_minmax)
   {
     GannLine ("Max 3 week","Line",Time[maxN3],High[maxN3],TimeD00,MW_2,SaddleBrown, 1,1,31);
     GannLine ("Min 3 week","Line",Time[minN3],Low[minN3], TimeD00,MW_2,SaddleBrown, 1,1,31);
   }    
   
   //Angle of yesterday
    if (FromShadow==TRUE)
     {
         if (Close[BarD2]>Open[BarD2])
            Pr3=High[BarD2];
            else Pr3=Low[BarD2];
     
         if (Close[BarD1]>Open[BarD1])
            Pr2=High[BarD1];
            else Pr2=Low[BarD1]; 

         if (Close[BarD0]>Open[BarD0])
            Pr1=High[BarD0];
            else Pr1=Low[BarD0];
      }
     else 
         {
          Pr3=Close[BarD2+1];
          Pr2=Close[BarD1+1];
          Pr1=Close[BarD0+1];
         }
   //standard grid making
     if (Grid_standard)
     {
      Grid_today=False; 
      Grid_yesterday=False;
      Grid_double_H_1=False;
      Day_before_yesterday=False;
      GannLine ("Grid based on yesterday","Grid",TimeD1,Pr2,TimeD00,MD,Maroon,0,1,31);
      GannLine ("Grid based on current day","Grid",TimeD0,Pr1,TimeD00,MD,Navy, 0,1,31);
     }
   
   //Angle of yesterday
     if (Line)GannLine ("Angle of yesterday","Line",TimeD1,  Pr2,   TimeD00,MD,Maroon,0,1,31);
     
   //Angle of the current day
     if (Line)GannLine ("Angle of the current day","Line",TimeD0,Pr1,     TimeD000,MD,Navy, 0,1,31);
     
     if (Day_before_yesterday) //angle of yesterday and day before yesterday
     {
      if (Grid_double_H_1)
      {
        if (Grid_yesterday)GannLine ("Grid based on angle of the day before yesterday","Grid",TimeD2,Pr3,TimeD0,MD,Maroon,0,2,31);
        if (Grid_today)GannLine ("Grid based on angle of yesterday","Grid",TimeD1,Pr1,TimeD00,MD,Navy, 0,2,31);
      }
      else
      {
        if (Grid_yesterday)GannLine ("Grid based on the day before yesterday","Grid",TimeD2,  Pr3,   TimeD1,MD,Maroon,0,1,31);
        if (Grid_today)GannLine ("Grid based on the yesterday","Grid",TimeD1,  Pr2,   TimeD0,MD,Navy, 0,1,31);
      } 
     }
     else //angle of yesterday and today
     {
      if (Grid_double_H_1)
      {
        if (Grid_yesterday)GannLine ("Grid based on yestreday","Grid",TimeD1,Pr2,TimeD00,MD,Maroon,0,2,31);
        if (Grid_today)GannLine ("Grid based on the current day","Grid",TimeD0,Pr1,TimeD00+86400,MD,Navy, 0,2,31);
      }
      else
      {
        if (Grid_yesterday)GannLine ("Grid based on yestreday","Grid",TimeD1,Pr2,TimeD0,MD,Maroon,0,1,31);
        if (Grid_today)GannLine ("Grid based on the current day","Grid",TimeD0,Pr1,TimeD00,MD,Navy, 0,1,31);
      }
     } 
     
   //min max of yesterday
     if (Day_minmax)
     {
      if (Day_before_yesterday)
       {
        GannLine ("max day before yesterday","Line",Time[maxD2],High[maxD2],TimeD0,MD,Lime, 1,1,31);
        GannLine ("min day before yesterday","Line",Time[minD2], Low[minD2],TimeD0,MD,Lime, 1,1,31);
       }
      else
       {
        GannLine ("max of yesterday","Line",Time[maxD1],High[maxD1],TimeD00,MD,Lime, 1,1,31);
        GannLine ("min of yesterday","Line",Time[minD1], Low[minD1],TimeD00,MD,Lime, 1,1,31);
       }
     }
    
   //Fibo Channels
     if (High_Low)
     {
     Channel ("Channel based on min_max yesterday+", Time[maxD1],High[maxD1], Time[minD1], Low[minD1],  MD,  31, ChColorMax, ChStyleMax, ChWightMax );
     Channel ("Channel based on min_max yesterday-", Time[maxD1],High[maxD1], Time[minD1], Low[minD1],  -MD,  31, ChColorMin, ChStyleMin, ChWightMin  );
     }
     if (Opening_yesterday)
     {
     Channel ("Channel based on openning yesterday+", TimeD1,  Pr2, TimeD0+86400*3, Pr2,  MD,  31, ChColorOpenUp, ChStyleMax, ChWightMax );
     Channel ("Channel based on openning yesterday-", TimeD1,  Pr2, TimeD0+86400*3, Pr2,  -MD,  31, ChColorOpenDown, ChStyleMin, ChWightMin  );
     }

   //Resistance and support
     if (S_R)
     {
        Line ("Max week ago", High[maxN1], S_R_Max_Style, S_R_Max_Wight,31);
        Line ("Min week ago", Low[minN1], S_R_Min_Style, S_R_Min_Wight,31);
        
        Line ("Max second week", High[maxN2], S_R_Max_Style, S_R_Max_Wight,31);
        Line ("Min second week", Low[minN2], S_R_Min_Style, S_R_Min_Wight,31);
        
        Line ("Max third week", High[maxN3], S_R_Max_Style, S_R_Max_Wight,31);
        Line ("Min third week", Low[minN3], S_R_Min_Style, S_R_Min_Wight,31);
        
        Line ("Max forth week", High[maxN4], S_R_Max_Style, S_R_Max_Wight,31);
        Line ("Min forth week", Low[minN4], S_R_Min_Style, S_R_Min_Wight,31);
     }
     
   // Drawing daily Fibo_S_R
     if (S_R_Fibo)
     {
        P = Open[BarD0];
        Fibo_S_R("Openning of day", P, TimeD0, P, TimeD00, 31);
        Fibo_S_R("R_1", P, TimeD0, P+13*Point*10, TimeD00, 31);
        Fibo_S_R("S_1", P, TimeD0, P-13*Point*10, TimeD00, 31);
        Fibo_S_R("R_2", P, TimeD0, P+21*Point*10, TimeD00, 31);
        Fibo_S_R("S_2", P, TimeD0, P-21*Point*10, TimeD00, 31);
        Fibo_S_R("R_3", P, TimeD0, P+34*Point*10, TimeD00, 31);
        Fibo_S_R("S_3", P, TimeD0, P-34*Point*10, TimeD00, 31);
        Fibo_S_R("R_4", P, TimeD0, P+55*Point*10, TimeD00, 31);
        Fibo_S_R("S_4", P, TimeD0, P-55*Point*10, TimeD00, 31);
        Fibo_S_R("R_5", P, TimeD0, P+89*Point*10, TimeD00, 31);
        Fibo_S_R("S_5", P, TimeD0, P-89*Point*10, TimeD00, 31);
        Fibo_S_R("R_6", P, TimeD0, P+144*Point*10, TimeD00, 31);
        Fibo_S_R("S_6", P, TimeD0, P-144*Point*10, TimeD00, 31);
      }
        
   //Fibo levels based on yesterday min max
  if (FiboSelect == 1)
  { 
      Fibo("Fibo",FiboLevel,FiboDescription,Time[maxD1],High[maxD1],Time[minD1],Low[minD1],FiboColor,FiboStyle,FiboWight,31);
  }
  if (FiboSelect == 2)
  {
      Fibo("Gann",FiboGann,FiboGannDescription,Time[maxD1],High[maxD1],Time[minD1],Low[minD1],FiboColor,FiboStyle,FiboWight,31);
  }
  
   WindowRedraw();
    
return(0);
 }
 
 //--------------------------------------------------------------------------------
 int WriteGH4()
   {
   int TimeD00;//beginning of next day
   int TimeN00;//beginning of next week
   int TimeN0; //beginning of current week
   int TimeN1; //beginning of last week
   int TimeN2; //beginning of last? week
   int TimeM; //beginning of month
   int minN1; //min bar last week
   int maxN1; //max bar last week
   int minN2; //min bar week before last week
   int maxN2; //max bar week before last week
   int i=0, j;
   int D;
   double Pr1, Pr2, Pr3, MW, MV;
   double rez, h, l, r, t;

// time tomorrow opens
      if (ExtDay==False) TimeD00=TimeD0+86400; 
      else               TimeD00=TimeD0+86400*2; 

// time current week openned
   D=TimeDayOfWeek(TimeD0);
   TimeN0=TimeD0-(D-1)*86400;

// time last week openned
   TimeN1=TimeN0-86400*7;
   
// time last week openned
   TimeN2=TimeN1-86400*7;

//openning next week
    TimeN00=TimeN0+86400*5;

// min/max last week
   int BarN0=iBarShift(NULL,0,TimeN0+DT);
   int BarN1=iBarShift(NULL,0,TimeN1+DT);
   j=iBarShift(NULL,0,TimeN0+DT);
   i=BarN1-j;
         maxN1=iHighest(NULL, 0, MODE_HIGH,i, j+1);
         minN1=iLowest (NULL, 0, MODE_LOW ,i, j+1);
   int BarN2=iBarShift(NULL,0,TimeN2+DT);
   j=iBarShift(NULL,0,TimeN1+DT);
   i=BarN2-j;
         maxN2=iHighest(NULL, 0, MODE_HIGH,i, j+1);
         minN2=iLowest (NULL, 0, MODE_LOW ,i, j+1);

// calculating parameter 
         if (Close[BarN1]>Open[BarN1])
            Pr2=High[BarN1];
            else Pr2=Low[BarN1]; 

         if (Close[BarN0]>Open[BarN0])
            Pr1=High[BarN0];
            else Pr1=Low[BarN0];

 if (pH4==0)
   {
    h=MathAbs(NormalizeDouble(High[maxN1],4)-NormalizeDouble(Low[minN1],4))/Point;
    r=MathPow(120,2); 
    rez=MathPow(h,2);
    MW=MathSqrt(rez+r)/100*Period()/240;
   }          
 else MW=pH4;
 if (Last_week)
  {
    h=MathAbs(NormalizeDouble(High[maxN2],4)-NormalizeDouble(Low[minN2],4))/Point;
    r=MathPow(120,2); 
    rez=MathPow(h,2);
    MV=MathSqrt(rez+r)/100*Period()/240;
    MW=MV;
  }
  
  
 Comment (WindowExpertName(	),"\n","\n",
          "Scale last week = ",DoubleToStr(NormalizeDouble(MW,4),4),"\n");

 // time lines

  VLine("End of the current week",TimeN00,DodgerBlue,STYLE_DOT,1,OBJ_PERIOD_H4);
  VLine("Beginning of the currenrt week",TimeN0,DodgerBlue,STYLE_DOT,1,OBJ_PERIOD_H4);
  VLine("Beginning of the last week",TimeN1,DodgerBlue,STYLE_DOT,1,OBJ_PERIOD_H4);
  VLine("Beginning of the current day",TimeD0,PaleGreen,STYLE_DOT,1,OBJ_PERIOD_H4);
  VLine("End of the current day",TimeD00,PaleGreen,STYLE_DOT,1,OBJ_PERIOD_H4);

   // angle of the last week
   if (FromShadow==False)
     {
      Pr1=Close[BarN0+1];
      Pr2=Close[BarN1+1];
      Pr3=Close[BarN2+1];
     }
     
   if (Last_week) 
     {
      if (Grid_double_H_4)
       { 
        GannLine ("Angle of the week before last week","Grid",TimeN2, Pr3,TimeN1+86400*5,MW,Maroon,0,2,OBJ_PERIOD_H4);
        GannLine ("Angle of the last week","Grid",TimeN1, Pr2,TimeN0,MW,Navy,0,1,OBJ_PERIOD_H4);
       }
      else
       {
        GannLine ("Angle of the week before last week","Grid",TimeN2, Pr3,TimeN1,MW,Maroon,0,1,OBJ_PERIOD_H4);
        GannLine ("Angle of the last week","Grid",TimeN1, Pr2,TimeN0,MW,Navy,0,1,OBJ_PERIOD_H4);
       }
     }
     else 
     {
      if (Grid_double_H_4)
       { 
        GannLine ("Angle of the last week","Grid",TimeN1, Pr2,TimeN0+86400*5,MW,Maroon,0,2,OBJ_PERIOD_H4);
        GannLine ("Angle of the current week","Grid",TimeN0, Pr1,TimeN00,MW,Navy,0,1,OBJ_PERIOD_H4);
       }
      else
       {
        GannLine ("Angle of the last week","Grid",TimeN1, Pr2,TimeN0,MW,Maroon,0,1,OBJ_PERIOD_H4);
        GannLine ("Angle of the current week","Grid",TimeN0, Pr1,TimeN00,MW,Navy,0,1,OBJ_PERIOD_H4);
       }
     }
      
   //min max last week
      if (Last_week)
       { 
        GannLine ("Max of the week before last week","Line",Time[maxN2], High[maxN2],TimeN0,MW,Gold,0,1,OBJ_PERIOD_H4);
        GannLine ("Min of the week before last week","Line",Time[minN2], Low[minN2],TimeN0,MW,Gold,0,1,OBJ_PERIOD_H4);
       }
      else
       {
        GannLine ("Max of the last week","Line",Time[maxN1], High[maxN1],TimeN00,MW,Gold,0,1,OBJ_PERIOD_H4);
        GannLine ("Min of the last week","Line",Time[minN1], Low[minN1],TimeN00,MW,Gold,0,1,OBJ_PERIOD_H4);
       }
   
  //Fibo Channels
     if (High_Low)
     {
     Channel ("Channel based on min_max yesterday+", Time[maxN1],High[maxN1], Time[minN1], Low[minN1],  MW,  OBJ_PERIOD_H4, ChColorMax, ChStyleMax, ChWightMax );
     Channel ("Channel based on min_max yesterday-", Time[maxN1],High[maxN1], Time[minN1], Low[minN1],  -MW,  OBJ_PERIOD_H4, ChColorMin, ChStyleMin, ChWightMin  );
     }
     if (Opening_yesterday)
     {
     Channel ("Channel based on openning yesterday+", TimeN1,  Pr2, TimeN0+86400*7, Pr2,  MW,  OBJ_PERIOD_H4, ChColorOpenUp, ChStyleMax, ChWightMax );
     Channel ("Channel based on openning yesterday-", TimeN1,  Pr2, TimeN0+86400*7, Pr2,  -MW,  OBJ_PERIOD_H4, ChColorOpenDown, ChStyleMin, ChWightMin  );
     }

   
   //Fibo levels based on min max of the last week
  if (FiboSelect == 1)
  { 
      Fibo("Fibo",FiboLevel,FiboDescription,Time[maxN1],High[maxN1],Time[minN1],Low[minN1],FiboColor,FiboStyle,FiboWight,OBJ_PERIOD_H4);
  }
  if (FiboSelect == 2)
  {
      Fibo("Gann",FiboGann,FiboGannDescription,Time[maxN1],High[maxN1],Time[minN1],Low[minN1],FiboColor,FiboStyle,FiboWight,OBJ_PERIOD_H4);
  }

   WindowRedraw();
   
return(0);
 }
 
// ---------------------------------------------------------------------------- 
//  Drawing pair of lines\ Gann grids                                        |
//-----------------------------------------------------------------------------   
void GannLine (string name, string type, datetime x1, double y1, datetime x2, double Mashtab, color Color, int Style, int Widht, int period)
  {
     if (type=="Line") ObjectCreate(Pr+name+"+",OBJ_GANNLINE,0,x1,y1,x2,0);
     if (type=="Grid") ObjectCreate(Pr+name+"+",OBJ_GANNGRID,0,x1,y1,x2,0);
       ObjectSet (Pr+name+"+",OBJPROP_COLOR,Color);
       ObjectSet (Pr+name+"+",OBJPROP_STYLE,Style);
       ObjectSet (Pr+name+"+",OBJPROP_WIDTH,Widht);
       ObjectSet (Pr+name+"+",OBJPROP_TIMEFRAMES,period);
       ObjectSet (Pr+name+"+",OBJPROP_SCALE,Mashtab);
   
    if (type=="Line") ObjectCreate(Pr+name+"-",OBJ_GANNLINE,0,x1,y1,x2,0);
    if (type=="Grid") ObjectCreate(Pr+name+"-",OBJ_GANNGRID,0,x1,y1,x2,0);    
       ObjectSet (Pr+name+"-",OBJPROP_COLOR,Color);
       ObjectSet (Pr+name+"-",OBJPROP_STYLE,Style);
       ObjectSet (Pr+name+"-",OBJPROP_WIDTH,Widht);
       ObjectSet (Pr+name+"-",OBJPROP_TIMEFRAMES,period);
       ObjectSet (Pr+name+"-",OBJPROP_SCALE,-Mashtab);
   
  return(0);
  }
  
// ---------------------------------------------------------------------------- 
//  Drawing of Fibo channels                                                    |
//-----------------------------------------------------------------------------
void Channel (string name, datetime x1, double y1, datetime x2, double y2, double Mashtab, int period, color ChColor, int ChStyle, int ChWidth )
{
   int BarN0=iBarShift(NULL,0,x1);
   double y3=y1 - ((double)BarN0)*Mashtab*Point;
   

   ObjectCreate(Pr+name,OBJ_FIBOCHANNEL,0,x1,y1, iTime( NULL, 0, 0) , y3,x2,y2 );

   ObjectSet (Pr+name,OBJPROP_LEVELCOLOR,ChColor);
   ObjectSet (Pr+name,OBJPROP_LEVELSTYLE,ChStyle);
   ObjectSet (Pr+name,OBJPROP_LEVELWIDTH,ChWidth);
   ObjectSet (Pr+name,OBJPROP_TIMEFRAMES,period);
  
   ObjectSet (Pr+name,OBJPROP_FIBOLEVELS,20);
   ObjectSet (Pr+name,OBJPROP_FIRSTLEVEL +0,0);
   ObjectSet (Pr+name,OBJPROP_FIRSTLEVEL+1,0.5);
   ObjectSet (Pr+name,OBJPROP_FIRSTLEVEL+2,1);
   ObjectSet (Pr+name,OBJPROP_FIRSTLEVEL+3,1.5);
   ObjectSet (Pr+name,OBJPROP_FIRSTLEVEL+4,2);
   ObjectSet (Pr+name,OBJPROP_FIRSTLEVEL+5,2.5);
   ObjectSet (Pr+name,OBJPROP_FIRSTLEVEL+6,3);
   ObjectSet (Pr+name,OBJPROP_FIRSTLEVEL+7,3.5);
   ObjectSet (Pr+name,OBJPROP_FIRSTLEVEL+8,4);
   ObjectSet (Pr+name,OBJPROP_FIRSTLEVEL+9,4.5);
   ObjectSet (Pr+name,OBJPROP_FIRSTLEVEL+10,5);
   ObjectSet (Pr+name,OBJPROP_FIRSTLEVEL+11,-0.5);
   ObjectSet (Pr+name,OBJPROP_FIRSTLEVEL+12,-1);
   ObjectSet (Pr+name,OBJPROP_FIRSTLEVEL+13,-1.5);
   ObjectSet (Pr+name,OBJPROP_FIRSTLEVEL+14,-2);
   ObjectSet (Pr+name,OBJPROP_FIRSTLEVEL+15,-2.5);
   ObjectSet (Pr+name,OBJPROP_FIRSTLEVEL+16,-3);
   ObjectSet (Pr+name,OBJPROP_FIRSTLEVEL+17,-3.5);
   ObjectSet (Pr+name,OBJPROP_FIRSTLEVEL+18,-4);
   ObjectSet (Pr+name,OBJPROP_FIRSTLEVEL+19,-4.5);
   ObjectSet (Pr+name,OBJPROP_FIRSTLEVEL+20,-5);

   return(0);
}

// ---------------------------------------------------------------------------- 
//  Drawing of vertical line                                             |
//-----------------------------------------------------------------------------  
void VLine (string name, datetime x1, color Color, int Style,int Back, int period)
{
   ObjectCreate(Pr+name,OBJ_VLINE,0,x1,0);
   ObjectSet(Pr+name,OBJPROP_COLOR,Color);
   ObjectSet(Pr+name,OBJPROP_STYLE,Style);
   ObjectSet(Pr+name,OBJPROP_BACK,Back);
   ObjectSet(Pr+name,OBJPROP_TIMEFRAMES,period);
   
  return(0);
}

// ---------------------------------------------------------------------------- 
//  Drawing of horizontal line                                            |
//-----------------------------------------------------------------------------  
void Line (string name, double y1, int Style, int Width, int period)
{
  color Color;
  if (y1 > Bid) Color = R_Color;
  if (y1 < Bid) Color = S_Color;
  ObjectCreate(Pr+name,OBJ_HLINE,0,0,y1);
  ObjectSet(Pr+name,OBJPROP_COLOR,Color);
  ObjectSet(Pr+name,OBJPROP_STYLE,Style);
  ObjectSet(Pr+name,OBJPROP_WIDTH,Width);
  ObjectSet(Pr+name,OBJPROP_TIMEFRAMES,period);
   
  return(0);
}

//--------------------------------------------------------
// Fibo lines output
//--------------------------------------------------------
void Fibo(string name,  double fi_[], string fitxt_[], datetime x1, double y1, datetime x2,double y2,color Color, int Style, int Widht, int period)
{
   int j = 0;
   int m = 0;
   int p = 0;

   while (fi_[j] < 100 )
   {
         if (fi_[j] >=0 )
         {
            p++;
         }
         else
         {
            m++;
         }
         j++;
   }
   string FiboNameP = Pr+name + "p";
   string FiboNameM = Pr+name + "m";
   
   ObjectCreate(FiboNameP,OBJ_FIBO,0,x1,y1,x2,y2);
   ObjectSet(FiboNameP,OBJPROP_FIBOLEVELS,p);

   ObjectCreate(FiboNameM,OBJ_FIBO,0,x1,y1,x2,y2);
   ObjectSet(FiboNameM,OBJPROP_FIBOLEVELS,m);
   m = 0;
   p = 0;
   for ( int i = 0; i < j; i++ )
   {
         
         if (fi_[i] >=0 )
         {
            ObjectSet(FiboNameP,OBJPROP_FIRSTLEVEL+p,fi_[i]);
            ObjectSetFiboDescription(FiboNameP, p, fitxt_[i]); 
            p++;
         }
         else
         {
            ObjectSet(FiboNameM,OBJPROP_FIRSTLEVEL+m,fi_[i]);
            ObjectSetFiboDescription(FiboNameM, m, fitxt_[i]); 
            m++;
         }

   }
   ObjectSet(FiboNameP,OBJPROP_LEVELCOLOR,Color);
   ObjectSet(FiboNameP,OBJPROP_LEVELSTYLE,Style);
   ObjectSet(FiboNameP,OBJPROP_LEVELWIDTH,Widht);
   ObjectSet(FiboNameP,OBJPROP_TIMEFRAMES,period);


   ObjectSet(FiboNameM,OBJPROP_LEVELCOLOR,Color);
   ObjectSet(FiboNameM,OBJPROP_LEVELSTYLE,Style);
   ObjectSet(FiboNameM,OBJPROP_LEVELWIDTH,Widht);
   ObjectSet(FiboNameM,OBJPROP_TIMEFRAMES,period);
   
  return(0);
  }

//+------------------------------------------------------------------+
// Drawing daily Fibo_S_R                                        | 
//+------------------------------------------------------------------+
void Fibo_S_R (string name, double y1, datetime x1, double y2, datetime x2, int period)
{
      color Color;
      if (y1 == y2) Color = Op_Day_Color;
      if (y1 < y2)  Color = R_Fibo_Color;
      if (y1 > y2)  Color = S_Fibo_Color;
      ObjectCreate(Pr+name,OBJ_TREND,0,x1,y2,x2,y2);
      ObjectSet(Pr+name,OBJPROP_COLOR,Color);
      ObjectSet(Pr+name,OBJPROP_STYLE,S_R_Fibo_Style);
      ObjectSet(Pr+name,OBJPROP_WIDTH,S_R_Fibo_Width);
      ObjectSet(Pr+name,OBJPROP_RAY,S_R_Fibo_Ray);
      ObjectSet(Pr+name,OBJPROP_TIMEFRAMES,period);
   
  return(0);
}

//+------------------------------------------------------------------+
// Deinstallator of objects                                             | 
//+------------------------------------------------------------------+
void Delete_My_Obj(string Prefix)
{
   for(int k = ObjectsTotal()-1; k >= 0; k --)  // by total objects
   {
      string Obj_Name = ObjectName(k);   // asking name of the object
      string Head = StringSubstr(Obj_Name, 0, StringLen(Prefix));// getting first sim

      if (Head == Prefix)// object found, ..
      {
         ObjectDelete(Obj_Name);
      }                
        
   }
}     
//+------------------------------------------------------------------+